(document:surround "/std/base")
(document:insert "/std/functions")

(document:envelop with-translation _ "alterator-net-pptp")

;;;;;;;;;;;;;;;;;;;;;;

(gridbox columns "20;40;60;20"
         ;;
	 (spacer)
         (label (_ "Connection"))
         (hbox (document:id connections (combobox))
               (document:id name (edit "" invisible widget-name "name")))
	 (spacer)


	 ;;
	 (spacer)
         (document:id del-button (button (_ "Delete...")))
         (document:id new-button (button (_ "Create new...")))
	 (spacer)


         ;;
         (spacer)
         (separator)
         (separator)
         (spacer)


	 ;;
	 (spacer)
         (document:id info (label ""))
	 (spacer)
	 (spacer)


         ;;
         (spacer)
         (label (bold (_ "Server")) align "right")
         (document:id server (edit "" widget-name "server"))
         (spacer)
         ;;
         (spacer)
         (label (bold (_ "Login")) align "right")
         (document:id login (edit "" widget-name "login"))
         (spacer)
         ;;
         (spacer)
         (label (bold (_ "Password")) align "right")
         (document:id password (edit "" echo stars widget-name "password"))
         (spacer)
         ;;
         (spacer)
         (label (bold (_ "Walk through interface")) align "right")
         (document:id iface (combobox widget-name "iface"))
         (spacer)
         ;;
         (spacer)
         (label (_ "MPPE encryption") align "right")
         (document:id mppe (checkbox "" widget-name "mppe"))
         (spacer))

(hbox
 align "center"
 (document:id apply-button (button (_ "Apply")))
 (document:id reset-button (button (_ "Reset")))
 (document:id quit-button (button (_ "Quit") )))


;;;;;;;;;;;;;;;;;;;;;;
(define (go-new)
  (cell-set! new-mode #t)
  (name visibility #t)
  (connections invisible)
  (update-constraints "new" "/net-pptp"))

(define (go-edit)
  (cell-set! new-mode #f)
  (name invisible)
  (connections visibility #t)
  (update-constraints "write" "/net-pptp"))

;;;;;;;;;;;;;;;;;;;;;;
(define gates (woo-list-names "/net-pptp/pppX/avail_ifaces"))
(define new-mode (make-cell #f))

(define (update-connection name)
  (let ((data (woo-read-first (string-append "/net-pptp/" name))))
    (info text (string-append "<small>(" (woo-get-option data 'info) ")</small>"  ))
    (server text (woo-get-option data 'server))
    (mppe state (woo-get-option data 'mppe))
    (login text (woo-get-option data 'login))
    (password text "")
    (iface current (or (string-list-index (woo-get-option data 'iface) gates) 0))))

(define (call-update-connection)
  (format #t "call-update-connection~%")
  (and (> (connections count) 0)
       (connections current 0 selected)))

(define (write-connection name)
  (woo-catch/message
   (thunk
    (let ((pwd (password text)))
      (apply woo-write/constraints (string-append "/net-pptp/" name)
             'server (server text)
             'iface (iface text)
             'mppe (mppe state)
             'login (login text)
             (if (not-empty-string? pwd) (list 'password pwd) '()))))))


(define (new-connection name)
  (and
   (woo-catch/message
    (thunk
     (woo-new/constraints "/net-pptp/"
              'name name
              'server (server text)
              'iface (iface text)
              'mppe (mppe state)
              'login (login text)
              'password (password text))
     (connections append-row name
                  current (connections count))
     #t))
   (go-edit)))

(define (delete-connection name)
  (woo-delete (string-append "/net-pptp/" name))
  (format #t "delete-connections=~S,~S~%" (connections current) (connections text))
  (connections remove (connections current))
  (format #t "delete-connections=~S,~S~%" (connections current) (connections text))
  )

(define (get-number x)
  (string->number (substring x 3 (string-length x))))

(define (first-available)
  (cond-plistq
   'name
   (process-defaults (read-constraints "new" "/net-pptp" '()) '())
   ""))

(define (clear-connection)
  ;;clear fields
  ((widgets name server login password info)
   text "")
  (iface current 0)
  (mppe state #f)
  (name text (first-available)))

;;;;;;;;;;;;;;;;;;;;;;;
(connections (when selected
               (update-connection (connections text))))

(apply-button (when clicked
                (if (cell-ref new-mode)
                    (new-connection (name text))
                    (write-connection (connections text)))))

(quit-button (when clicked
               (document:end)))

(reset-button (when clicked
                (if (cell-ref new-mode)
                    (clear-connection)
                    (and (>= (connections current) 0)
                         (connections selected)))))

(new-button (when clicked
              (go-new)
              (clear-connection)))

(del-button (when clicked
              (if (cell-ref new-mode)
                  (go-edit)
                  (delete-connection (connections text)))
              (clear-connection)
              (call-update-connection)))

;;;;;;;;;;;;;;;;;;;;;;;
(iface rows gates current 0)
(connections rows (woo-list-names "/net-pptp"))
(call-update-connection)

(document:root
 (when loaded
   (update-constraints "write" "/net-pptp")))
